// Hook v 0.2 file compressor.
// (C) 2007, Nania Francesco Antonio (Italia - Mer (MESSINA))
// Ari coder by Matt Mahoney (C) 2002
// under GPL, http://www.gnu.org/licenses/gpl.txt
// To compile: g++ -O Hook.cpp

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <cassert>
#include <stdio.h>
FILE *in;
FILE *out;
unsigned long memsize ;
unsigned char limit,length;
unsigned long x2,x1,xmid,x,bit,filesize,pos,control,bwr,ewr,tot;
unsigned char mbit;
typedef struct emubrain {struct emubrain *ahead[2];float  cxt[2];} branch;
float fct=0.1f;
branch *wizard;
branch *sum;
branch *branchmem;
branch *maxbranch;
branch *addrb;
branch mbuf[1<<16];

int flush()
{

   for (int j=0;j<256;j++)
   for (int i=0;i<255;i++)
   {
   if (i<127)
   {
   mbuf[j+(i<<8)].ahead[0] = &mbuf[j+(((i<<1) + 1)<<8)];
   mbuf[j+(i<<8)].ahead[1] = &mbuf[j+(((i<<1) + 2)<<8)];
   }
   else
   {
   mbuf[j+(i<<8)].ahead[0] = &mbuf[i+1];
   mbuf[j+(i<<8)].ahead[1] = &mbuf[i-127];
   }
   mbuf[j+(i<<8)].cxt[0] = fct;
   mbuf[j+(i<<8)].cxt[1] = fct;
   }

   addrb = branchmem;
   wizard = &mbuf[0];
}
int createbrain(unsigned long memsize)
{

   branchmem = (branch*)malloc(memsize);
   if (branchmem == (branch*) NULL)
   {
      fprintf(stderr,"No Memory!\n");
      exit(1);
   }
   maxbranch = branchmem + (memsize/sizeof(branch)) - 20;
   flush();
}


int p()
{
   return (int) (4095.0*(wizard->cxt[1] / (wizard->cxt[1] +wizard->cxt[0]))) 
;
}

void update(int y)

{
   float factor;
   if (wizard->cxt[y] >= limit && 
wizard->ahead[y]->cxt[0]+wizard->ahead[y]->cxt[1]>= length + wizard->cxt[y])
   {
   addrb++;
   sum=addrb;
   factor = 
wizard->cxt[y]/(wizard->ahead[y]->cxt[1]+wizard->ahead[y]->cxt[0]);
   sum->cxt[0] = wizard->ahead[y]->cxt[0] * factor;
   sum->cxt[1] = wizard->ahead[y]->cxt[1] * factor;
   wizard->ahead[y]->cxt[0] -= sum->cxt[0];
   wizard->ahead[y]->cxt[1] -= sum->cxt[1];
   sum->ahead[0] = wizard->ahead[y]->ahead[0];
   sum->ahead[1] = wizard->ahead[y]->ahead[1];
   wizard->ahead[y] = sum;
   }
   wizard->cxt[y]++;
   wizard=wizard->ahead[y];
   if (addrb > maxbranch)
   flush();

}
int decode()
{
  xmid = x1 + ((x2-x1) >> 12) * p();
  assert(xmid >= x1 && xmid < x2);
  int y=0;
  if (x<=xmid) {
    y=1;
    x2=xmid;
  }
  else
    x1=xmid+1;

  update(y);

  // Shift equal MSB's out
  while (((x1^x2)&0xff000000)==0)
  {
    int c;
    x1<<=8;
    x2=(x2<<8)+255;
    c=getc(in);
    x=(x<<8)+c;
  }
return y;
}

void encode(int y)
{
  xmid = x1 + ((x2-x1) >> 12) * p();
  assert(xmid >= x1 && xmid < x2);
  if (y)
    x2=xmid;
  else
    x1=xmid+1;

  update(y);

  // Shift equal MSB's out
  while (((x1^x2)&0xff000000)==0)
  {
    putc(x2>>24, out);
    x1<<=8;
    x2=(x2<<8)+255;

  }

}
void endx()
{
   printf( "Hook v 0.2 file compressor/archiver, (C) 2007 By Nania Francesco Antonio (Italy)\n"
           "This program is free software distributed without warranty under the terms\n"
           "of the GNU General Public License, see http://www.gnu.org/licenses/gpl.txt\n"
           "                              INSTRUCTION                                   \n"
           "To compress:   hook c [memory][limit][lenght] input output \n"
           "To decompress: hook d input output\n"
           "Compression option  Memory needed to compress/decompress\n"
           "------------------  ------------------------------------\n"
           " 0                    8 MB (fastest)\n"
           " 1                   16 MB\n"
           " 2                   32 MB\n"
           " 3                   64 MB\n"
           " 4                  128 MB\n"
           " 5                  256 MB\n"
           " 6                  512 GB\n"
           " 7                    1 GB (slowest)\n"
           " Limit =             [1-8]\n"
           " Length option      factor                              \n"
           "------------------  ------------------------------------\n"
           " 0                  1  (for small file)                 \n"
           " 1                  2                                   \n"
           " 2                  3                                   \n"
           " 3                  4                                   \n"
           " 4                  8                                   \n"
           " 5                  16                                  \n"
           " 6                  32                                  \n"
           " 7                  64  (for big file)                  \n"
           " Example compress: Hook c 1 1 7 in out                   \n"
           );
exit(1);
}
//////////////////////////// main ////////////////////////////

int main(int argc, char** argv) {

  // Chech arguments: fpaq3d c/d option input output
  if (  argc<4 || argc>7 )
  {
  endx();
  return 1;
  }
  if (  argv[1][0]!='c' && argv[1][0]!='d')
  {
  endx();
  return 1;
  }

  if (argv[1][0]=='c' && (argv[2][0]!='0' && argv[2][0]!='1'&&
  argv[2][0]!='2' && argv[2][0]!='3' && argv[2][0]!='4' && argv[2][0]!='5'&&
  argv[2][0]!='6' && argv[2][0]!='7') )
  {
  endx();
  }
   if (argv[1][0]=='c' && (argv[3][0]!='0' && argv[3][0]!='1'&&
  argv[3][0]!='2' && argv[3][0]!='3' && argv[3][0]!='4' && argv[3][0]!='5'&&
  argv[3][0]!='6' && argv[3][0]!='7') )
  {
  endx();
  }
     if (argv[1][0]=='c' && (argv[4][0]!='0' && argv[4][0]!='1'&&
  argv[4][0]!='2' && argv[4][0]!='3' && argv[4][0]!='4' && argv[4][0]!='5'&&
  argv[4][0]!='6' && argv[4][0]!='7') )
  {
  endx();
  }
   if (argv[1][0]=='c' && argc!=7 )
  {
    endx();
  }
    if (argv[1][0]=='d' && argc!=4 )
  {
    endx();
  }

  // Start timer
  clock_t start = clock();

  // Open files
  if (argv[1][0]=='c')
  {
  printf("Hook v 0.2 file compressor/archiver, (C) 2007 \n");
  printf("By Nania Francesco Antonio (Italy)\n");
  if (argv[2][0]=='0') {mbit=23;printf(" Memory = 8 Mb\n");}
  if (argv[2][0]=='1') {mbit=24;printf(" Memory = 16 Mb\n");}
  if (argv[2][0]=='2') {mbit=25;printf(" Memory = 32 Mb\n");}
  if (argv[2][0]=='3') {mbit=26;printf(" Memory = 64 Mb\n");}
  if (argv[2][0]=='4') {mbit=27;printf(" Memory = 128 Mb\n");}
  if (argv[2][0]=='5') {mbit=28;printf(" Memory = 256 Mb\n");}
  if (argv[2][0]=='6') {mbit=29;printf(" Memory = 512 Mb\n");}
  if (argv[2][0]=='7') {mbit=30;printf(" Memory = 1 Gb\n");}

  if (argv[3][0]=='1') {limit=1;}
  if (argv[3][0]=='2') {limit=2;}
  if (argv[3][0]=='3') {limit=3;}
  if (argv[3][0]=='4') {limit=4;}
  if (argv[3][0]=='5') {limit=5;}
  if (argv[3][0]=='6') {limit=6;}
  if (argv[3][0]=='7') {limit=7;}
  if (argv[3][0]=='8') {limit=8;}
  printf(" limit=%d",limit);
  printf(" \n");
  if (argv[4][0]=='0') {length=1;}
  if (argv[4][0]=='1') {length=2;}
  if (argv[4][0]=='2') {length=3;}
  if (argv[4][0]=='3') {length=4;}
  if (argv[4][0]=='4') {length=8;}
  if (argv[4][0]=='5') {length=16;}
  if (argv[4][0]=='6') {length=32;}
  if (argv[4][0]=='7') {length=64;}
  printf(" factor=%d",length);
  printf(" \n");
  in=fopen(argv[5], "rb");
  if (!in) perror(argv[5]), exit(1);
  out=fopen(argv[6], "wb");
  if (!out) perror(argv[6]), exit(1);
  }
  else
  {
  in=fopen(argv[2], "rb");
  if (!in) perror(argv[2]), exit(1);
  out=fopen(argv[3], "wb");
  if (!out) perror(argv[3]), exit(1);
  }

  int c;
  x1=0;
  x2=0xffffffff;
  x=0;
  // Compress
  if (argv[1][0]=='c')
  {
  fseek (in , 0 , SEEK_END);
  filesize = ftell (in);
  rewind (in);
  fwrite (&filesize , 1 , 4 , out);
  fwrite (&mbit , 1 , 1 , out);
  fwrite (&limit , 1 , 1 , out);
  fwrite (&length , 1 , 1 , out);
  memsize=1<<mbit;
  createbrain(memsize);
  while (pos<filesize)
  {
  c=getc(in);
  for (int i=7; i>=0; --i)
  encode((c >> i) &1);
  pos++;
  if (pos>control*(filesize/79))
  {
  printf(">");
  control++;
  }
  }
  for (int i=3; i>=0; --i) //Flush x2
  putc(x2>>(i<<3), out);


  }
  // Decompress
else
{
fread (&filesize , 1 , 4 , in);
fread (&mbit , 1 , 1 , in);
fread (&limit , 1 , 1 , in);
fread (&length , 1 , 1 , in);
memsize=1<<mbit;
createbrain(memsize);
for (int i=3; i>=0; --i) // get x
x+=getc(in)<<(i<<3);

while (pos<filesize)
    {
    c = 0;
    for (int i=7; i>=0; --i)
    c+=c+decode();
    putc(c,out);
    pos++;
    if (pos>control*(filesize/79))
    {
    printf(">");
    control++;
    }
    }
    }

   // Print results
  if (argv[1][0]=='c')
  {
  printf("%s (%ld bytes) compress to %s (%ld bytes) in %1.2f s.\n",
  argv[5], ftell(in), argv[6], ftell(out)
  ,((double)clock()-start)/CLOCKS_PER_SEC);
  }
  else
    {
  printf("%s (%ld bytes) decompress to %s (%ld bytes) in %1.2f s.\n"
  ,argv[2], ftell(in), argv[3], ftell(out)
  ,((double)clock()-start)/CLOCKS_PER_SEC);
  }
  return 0;

}
