/*
---------+---------+---------+---------+---------+---------+---------+---------+
Hook v 0.8c ADMC file compressor.(C) 2007, Nania Francesco Antonio 
(Italia - Mer (MESSINA))
under GPL, http://www.gnu.org/licenses/gpl.txt
To compile: g++ -O Hook.cpp .
Have invented: ADMC (Advanced DMC)  (C) 2007 Nania Francesco Antonio.
Include LZP Preprocessor.
Considered all the modifications brought to the program in the evolution of the 
same one has carried to me to create a being program to if that it has implemented 
the DMC to maximum possible levels (the DMC it leave from two fixed parameters 
limit=2 length=2) while the ADMC uses of the parameters automati to us that they 
are created from an only parameter (limit=x). I have removed completely the flush() 
in how much have left from the presupposed one that the created structure with 
the memory to disposition was purer than that one that would have been created 
with flush() (an operation that destroys the data in possession). Therefore task 
of finally being able to coin the name of this new more effective algorithm of 
the DMC from which it is born and to which it is inspired.
This is the ADMC.
*******************************************************************************
This program implements DMC, Copyright 1993, 1987
by Gordon V. Cormack, University of Waterloo, cormack@uwaterloo.ca
All rights reserved.
This code and the algorithms herein are the property of Gordon V. Cormack and 
Frank Schwellinger.Neither the code nor any algorithm herein may be included in
any software,device, or process which is sold, exchanged for profit, or for 
which a licence or royalty fee is charged.Permission is granted to use this code 
for educational, research, or commercial purposes, provided this notice is 
included, and provided this code is not used as described in the above paragraph.
*******************************************************************************
Description:
" a state machine in which each state represents a bitwise  context.Each state 
has 2 outgoing transitions corresponding to next bits 0 and 1,  and a count n0 
or n1 associated with each transition. Bit y (0 or 1) is compressed by arithmetic 
coding with probability ny/(n0+n1)(where ny is n0 or n1 according to y), and then 
ny is incremented. States are cloned (copied) whenever the incoming and outgoing 
counts exceed certain limits. This has the effect of creating a new context
extended by 1 bit. In the example  below, the  state  representing context 110 is 
cloned by creating a new state 0110 because the incoming 0 transition count (ny 
for y=0) from state 11 exceeded a limit. This transition is moved to point to 
the new state. Other incoming transitions (not shown) remain pointing to the 
original state. The  outgoing transitions are  copied. The  counts of the original
state are distributed to the  new state  in  proportion  to  the  movedtransition's 
contribution to those counts, which is w = ny/(n0+n1).
(Comment by Matt Mahoney :"The Paq data Compression Programs")
--> memory requirement of DMC->LZP + LZP buffer + DMC = 96 MB + x MB <--
*/

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <cassert>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
//////////// VARIABLES DECLARATION ////////////////////////////////////
FILE *in;
FILE *out;
unsigned long long filesize;
unsigned long gsis1,gsis2,gsis3,ri1,ri2,ri3,gl1,gl2,gl3,rcp,addbra,addbra2,detec;
unsigned long maxsize,scanned,umax,rc1,rposo,ubi,rumax,ok,dimu,ramax,rcx;
unsigned long el1,el2,di1,di2,el3,di3,esis1,esis2,exeat=0,LZ,avan,limit,memsize;
unsigned long x2,x1,xmid,x,bit,pos,control,tot,buf[1<<24],repos,posbit,incre ;
unsigned long digi1,digi2,digi3,digi4;
unsigned char mbit,memcre,nfi,nfo,profile; 
char *nf,*extens;
float fct=1.0f,flimit1,flimit2;
typedef struct emubrain {struct emubrain *ahead[2];float  cxt[2];} branch;
branch *wizard,*sum,*branchmem,*maxbranch,*addrb,*limbra;
typedef struct emubrain2 {struct emubrain2 *ahead2[2];float  cxt2[2];} branch2;
branch2 *wizard2,*sum2,*branchmem2,*maxbranch2,*addrb2,*limbra2;
unsigned char *buffer;
////////////////////////// Memory Commands /////////////////////////////////
unsigned char Peekb(unsigned char *memory)
{unsigned char result;memcpy(&result,memory,1);return (result);}
void Pokeb(unsigned char *memory,unsigned char value){memcpy(memory,&value,1);}
unsigned long Peekl(unsigned char *memory) 
{unsigned long result;memcpy(&result,memory,4);return (result); }
void Pokel(unsigned char *memory,unsigned long value) {memcpy(memory,&value,4);}
// EXE AND DLL CODER BY ILIA MURAVIEV DERIVED BY QUAD COMPRESSOR MAX 16MB //
void e8e9transform(int t, int n) 
{
for (int i = 0; i < (n - 4); ) 
{switch (buffer[i++]) 
{
case 0xe8: //-- CALL
case 0xe9: //-- JMP
int addr = *(reinterpret_cast<int *>(&buffer[i]));
if (t) 
{
  if ((addr >= -i) && (addr < (n - i)))
  addr += i;
  else if ((addr > 0) && (addr < n))
  addr -= n;
}
  else 
{
  if (addr < 0) 
  {
  if ((addr + i) >= 0)addr += n;
}
  else if (addr < n)
  addr -= i;
}
*(reinterpret_cast<int *>(&buffer[i])) = addr;
i += 4;
}
}
}
//////////////// PREDICTOR STRUCTURE ///////////////////////////////////////
void flush()
{
   addrb = branchmem;
   for (int j=0;j<256;j++)
   for (int i=0;i<255;i++)
   {
   if (i<127)
   {
   (addrb+j+(i<<8))->ahead[0]= addrb+j+(((i<<1)+ 1)<<8);
   (addrb+j+(i<<8))->ahead[1]= addrb+j+(((i<<1)+ 2)<<8);
   }
   else
   {
   (addrb+j+(i<<8))->ahead[0] = addrb+i+1;
   (addrb+j+(i<<8))->ahead[1] = addrb+i-127;
   }
   (addrb+j+(i<<8))->cxt[0] = fct;
   (addrb+j+(i<<8))->cxt[1] = fct;
   }
   
   addrb= branchmem+65279;
   wizard = branchmem;
   
}
void createbrain(unsigned long msize)
{
   // creation of Principal ADMC structure
   branchmem = (branch*)malloc(msize);
   if (branchmem == (branch*) NULL){fprintf(stderr,"No Memory!\n");exit(1);}
   maxbranch = branchmem + (msize/sizeof(branch)) - 20;
   limbra=branchmem + (((msize/sizeof(branch))/4)*3);
   addbra=((msize/sizeof(branch))/16);
   flush();
}
void flush2()
{
   addrb2 = branchmem2;
   for (int j=0;j<1024;j++)
   for (int i=0;i<1024;i++)
   {
   if (i<511)
   {
   (addrb2+j+(i<<10))->ahead2[0]= addrb2+j+(((i<<1) + 1)<<10);
   (addrb2+j+(i<<10))->ahead2[1]= addrb2+j+(((i<<1) + 2)<<10);
   }
   else
   {
   (addrb2+j+(i<<10))->ahead2[0] = addrb2+i+1;
   (addrb2+j+(i<<10))->ahead2[1] = addrb2+i-511;
   }
   (addrb2+j+(i<<10))->cxt2[0] = fct;
   (addrb2+j+(i<<10))->cxt2[1] = fct;
   }
   
   addrb2= branchmem2+(1<<20);
   wizard2 = branchmem2;

}
void createbrain2(unsigned long msize)
{
   // creation of LZP ADMC structure
   branchmem2 = (branch2*)malloc(msize);
   if (branchmem2 == (branch2*) NULL){fprintf(stderr,"No Memory!\n");exit(1);}
   maxbranch2 = branchmem2 + (msize/sizeof(branch2)) - 20;
   limbra2=branchmem2 + (((msize/sizeof(branch2))/4)*3);
   addbra2=((msize/sizeof(branch2))/16);
   flush2();
}

//// PROBABILITY LZP MODE////////////
float bp() {return (float)((float)wizard2->cxt2[1] / ((float)wizard2->cxt2[1] +(float)wizard2->cxt2[0])) ;}
//// PROBABILITY  NORMAL MODE////////////
float p()  {return (float)((float)wizard->cxt[1] / ((float)wizard->cxt[1] +(float)wizard->cxt[0])) ;}

//// UPDATE NORMAL MODE ///////////////////////////////////
void update(int y)

{
float factor,length;
factor=wizard->cxt[y]/(wizard->ahead[y]->cxt[0]+wizard->ahead[y]->cxt[1]);
length=flimit1+factor*factor;// by eugene (Special Thanks)
if (addrb<limbra && wizard->cxt[y] >= length && wizard->ahead[y]->cxt[0]+wizard->ahead[y]->cxt[1]>=(wizard->cxt[y]*factor)*(wizard->cxt[0]+wizard->cxt[1]) ) //***
{
addrb++;
sum=addrb;
sum->cxt[0] = wizard->ahead[y]->cxt[0] * factor;
sum->cxt[1] = wizard->ahead[y]->cxt[1] * factor;
sum->ahead[0] = wizard->ahead[y]->ahead[0];
sum->ahead[1] = wizard->ahead[y]->ahead[1];
wizard->ahead[y] = sum;
}
if (addrb==limbra) 
if (limbra+addbra<maxbranch) {flimit1+=0.5;limbra+=addbra; }
wizard->cxt[y]++;
wizard=wizard->ahead[y];
}
// UPDATE ADMC AND PRESERVE MEMORY ////////
void pupdate(int y)
{wizard=wizard->ahead[y];}
/// UPDATE LZP MODE //////////////////////////////
void bupdate(int y)
{
float factor,length;;
factor=wizard2->cxt2[y]/(wizard2->ahead2[y]->cxt2[0]+wizard2->ahead2[y]->cxt2[1]);
length=flimit2+factor*factor;// by eugene
if (addrb2<maxbranch2 && wizard2->cxt2[y] >= length && wizard2->ahead2[y]->cxt2[0]+wizard2->ahead2[y]->cxt2[1]>= (wizard2->cxt2[y]*factor)*(wizard2->cxt2[0]+wizard2->cxt2[1])) //***
{
addrb2++;
sum2=addrb2;
sum2->cxt2[0] = wizard2->ahead2[y]->cxt2[0] * factor;
sum2->cxt2[1] = wizard2->ahead2[y]->cxt2[1] * factor;
sum2->ahead2[0] = wizard2->ahead2[y]->ahead2[0];
sum2->ahead2[1] = wizard2->ahead2[y]->ahead2[1];
wizard2->ahead2[y] = sum2;
}
if (addrb2==limbra2) 
if (limbra2+addbra2<maxbranch2) {flimit2+=0.5;limbra2+=addbra2; }

wizard2->cxt2[y]++;
wizard2=wizard2->ahead2[y];
}

////////////////// ENCODER/DECODER ///////////////////////////
/*
This encoder/decoder is an evolution of the invented arithmetical coder from
Matt Mahoney (c) 2002, Nania Francesco Antonio (C) 2007.
*/
int decode()
{ 
if (ubi==0) 
xmid = x1 + (unsigned long)((x2-x1) * p()); // FLOATING PRECISION
else
xmid = x1 + (unsigned long)((x2-x1) * bp()); // FLOATING PRECISION

if (xmid<x1)xmid=x1;
if (xmid>=x2) xmid=x2-1;
int y=0;
if (x<=xmid) {y=1;x2=xmid;}
else x1=xmid+1;
if (ubi==0)
update(y);
else
bupdate(y);

// Shift equal MSB's out
while (((x1^x2)&0xff0000)==0)
{
int c;
x1<<=8;
x2=(x2<<8)+255;
c=getc(in);
tot++;
x=(x<<8)+c;
}
return y;
}

void encode(int y)
{
  if (ubi==0) 
  xmid = x1 + (unsigned long)((x2-x1) * p()); // FLOATING PRECISION
  else 
  xmid = x1 + (unsigned long)((x2-x1) * bp()); // FLOATING PRECISION

  if (xmid<x1) xmid=x1;
  if (xmid>=x2) xmid=x2-1;
  if (y)
  x2=xmid;
  else
  x1=xmid+1;

if (ubi==0)
update(y);
else
bupdate(y);
 

  // Shift equal MSB's out
  while (((x1^x2)&0xff0000)==0)
  {
    putc(x2>>16, out);
    tot++;
    x1<<=8;
    x2=(x2<<8)+255;

  }

}
void endx()
{
printf( 
"               _________________________________________                  \n" 
"              |Hook v 0.8c ADMC file compressor/archiver|                 \n" 
"              |(C)2007 By Nania Francesco Antonio(Italy)|                 \n"
"              |_________________________________________|                 \n"
"This program is free software distributed without warranty under the terms\n"
"of the GNU General Public License, see http://www.gnu.org/licenses/gpl.txt\n"
"                              INSTRUCTION                                 \n"
"To compress:   hook c [memsize][limit][enable lz]{[lz step]} in out       \n"
"To decompress: hook d input                                               \n"
" memsize        -> write MBytes [2-65535] ADMC buffer                     \n"
" Limit          -> write [1-255]                                          \n"
" LZ compression -> write [0-1]  (0=disabled, 1=enabled)                   \n"
" LZ step        -> write [1-255] (if enable LZP mode!)                    \n"
" Example   compress: Hook c 256 2 0 in out     (LZ disabled)              \n"
" Example   compress: Hook c 256 2 1 255 in out (LZ enabled)               \n"
" Example decompress: Hook d in                                            \n"
" Special Thanks: Matt Mahoney, Ilia Muraviev (for EXE coder),Eugene.      \n"
);
exit(1);
}
int Slen( char *f) 
{
unsigned char result=0;
while (*(f+result)!=0 )
result++;
return result;
}
void writename( char *n) 
{
int dpoint=0,lex=0;
extens = (char *)malloc(256);
unsigned char result=Slen(n);
unsigned char s;
fwrite (&result, 1 , 1 , out);
for (int i=0; i<result; i++)
{
s=*(n+i);
if (dpoint==1) {*(extens+lex)=s;lex++;}
if (s==0x2e) dpoint=1;
fwrite (&s, 1 , 1 , out);
}

}
void readname() 
{     
  unsigned char result;
  char s;
  int dpoint=0,lex=0;
  extens = (char *)malloc(256);
  fread (&result, 1 , 1 , in);
  nf = (char *)malloc(result);
  for (int i=0; i<result; i++)
  {
  fread (&s, 1 , 1 , in);
  *(nf+i)=s;
  }
  *(nf+result)=0;
  out=fopen(nf, "wb");
  printf("name=%s",nf);
  printf(" \n");
  if (!out) exit(1);
  for (int i=0; i<Slen(nf); i++)
  {
  s=*(nf+i);
  if (dpoint==1) {*(extens+lex)=s;lex++;}
  if (s==0x2e) dpoint=1;
  }
  *(extens+lex)=0;
  
}
void detectf() 
{    
// PREFILTER SELECTION ////////     
ri1=0;ri2=0;ri3=0;gl2=8;gl3=16;gsis1=1;gsis2=1;gsis3=1;di1=0;di2=0;di3=4;el2=8;el3=16;esis1=1;esis2=1;// default
if (Peekb(buffer)==66 && Peekb(buffer+1)==77 ) profile=1; //BMP
if (Peekb(buffer)==77 && Peekb(buffer+1)==90 && Peekb(buffer+2)==144 && Peekb(buffer+3)==0 && Peekb(buffer+4)==3 && Peekb(buffer+5)==0 && Peekb(buffer+6)==0 && Peekb(buffer+7)==0 ) profile=4; // exe// 
if (Peekb(buffer)==37 && Peekb(buffer+1)==80 && Peekb(buffer+2)==68 && Peekb(buffer+3)==70) profile=7;// pdf //
if (Peekb(buffer)==63 && Peekb(buffer+1)==95 && Peekb(buffer+2)==3 && Peekb(buffer+3)==0) profile=5; // hlp // 
if (Peekb(buffer)==208 && Peekb(buffer+1)==207 && Peekb(buffer+2)==17 && Peekb(buffer+3)==224) profile=6; // doc//
if (Peekb(buffer)==255 && Peekb(buffer+1)==216 && Peekb(buffer+2)==255 && Peekb(buffer+3)==224 && Peekb(buffer+6)==74 && Peekb(buffer+7)==70 && Peekb(buffer+8)==73 && Peekb(buffer+9)==70 ) profile=8; // jpg //
if (!strcmp( extens, "log") || !strcmp( extens, "LOG")) profile=1;
if (!strcmp( extens, "bmp") || !strcmp( extens, "BMP")) profile=2;
if (!strcmp( extens, "dic") || !strcmp( extens, "DIC")) profile=3;
if (!strcmp( extens, "exe") || !strcmp( extens, "EXE")) profile=4;
if (!strcmp( extens, "hlp") || !strcmp( extens, "HLP")) profile=5;
if (!strcmp( extens, "doc") || !strcmp( extens, "DOC")) profile=6;
if (!strcmp( extens, "pdf") || !strcmp( extens, "PDF")) profile=7;
if (!strcmp( extens, "jpg") || !strcmp( extens, "JPG")) profile=8;
if (!strcmp( extens, "dll") || !strcmp( extens, "DLL")) profile=4;
if (!strcmp( extens, "txt") || !strcmp( extens, "TXT")) profile=9;
if (!strcmp( extens, "iso") || !strcmp( extens, "ISO")) profile=10;
if (profile==1){ri1=0;ri2=0;ri3=0;gl2=0;gl3=8;gsis1=1;gsis2=1;gsis3=1;di1=0;di2=0;di3=4;el2=8;el3=16;esis1=1;esis2=1;printf("LOG file\n");}
if (profile==2){ri1=0;ri2=0;ri3=0;gl2=8;gl3=16;gsis1=1;gsis2=1;gsis3=1;di1=4;di2=4;di3=4;el2=4;el3=8;esis1=1;esis2=1;printf("IMAGE BMP\n");}
if (profile==3){ri1=4;ri2=4;ri3=4;gl2=0;gl3=4;gsis1=0;gsis2=1;gsis3=1;di1=4;di2=4;el2=4;di3=4;el3=8;esis1=1;esis2=1;printf("Dictionary\n");}
if (profile==4){ri1=0;ri2=0;ri3=0;gl2=8;gl3=16;gsis1=1;gsis2=1;gsis3=1;di1=4;di2=4;el2=4;di3=4;el3=8;esis1=1;esis2=1;exeat=1;printf("EXE file \n");}
if (profile==5){ri1=0;ri2=0;ri3=0;gl2=8;gl3=16;gsis1=1;gsis2=1;gsis3=1;di1=0;di2=0;el2=8;di3=0;el3=16;esis1=1;esis2=1;printf("Help file \n");}
if (profile==6){ri1=0;ri2=0;ri3=0;gl2=8;gl3=16;gsis1=1;gsis2=1;gsis3=1;di1=0;di2=0;el2=8;di3=0;el3=16;esis1=1;esis2=1;printf("DOC file \n");}
if (profile==7){ri1=0;ri2=0;ri3=0;gl2=8;gl3=16;gsis1=1;gsis2=1;gsis3=1;di1=4;di2=4;el2=4;di3=4;el3=8;esis1=1;esis2=1;printf("Acrobat Reader \n");}
if (profile==8){ri1=0;ri2=0;ri3=0;gl2=8;gl3=16;gsis1=1;gsis2=1;gsis3=1;di1=0;di2=0;el2=0;di3=8;el3=16;esis1=1;esis2=1;printf("IMAGE JPEG \n");}
if (profile==9){ri1=4;ri2=4;ri3=4;gl2=0;gl3=4;gsis1=0;gsis2=1;gsis3=1;di1=4;di2=4;el2=4;di3=4;el3=8;esis1=1;esis2=0;printf("Text \n");}
if (profile==10){ri1=0;ri2=0;ri3=0;gl2=8;gl3=16;gsis1=1;gsis2=1;gsis3=1;di1=0;di2=0;el2=8;di3=4;el3=16;esis1=1;esis2=1;printf("ISO image \n");}
}
void cwrite(int c)
{
ubi=0;for (int i=7; i>=0; --i){posbit=i;encode((c>>i)&1);}     
}
void cread()
{
int c;
ubi=0;c = 0;for (int i=7; i>=0; --i){posbit=i;c+=c+decode(); Pokeb(buffer+pos,c);}
}  
//////////////////////////// MAIN ////////////////////////////

int main(int argc, char** argv) 
{
// Chech arguments: hook c/d option input output /////////////////////////////
if (argc >6 && argc<9 && argv[1][0]=='c' && isdigit(*argv[2])) sscanf(argv[2],"%d",&digi1);
if (argc >6 && argc<9 && argv[1][0]=='c' && isdigit(*argv[3])) sscanf(argv[3],"%d",&digi2);
if (argc >6 && argc<9 && argv[1][0]=='c' && isdigit(*argv[4])) sscanf(argv[4],"%d",&digi3);
if (argc == 8 && argv[1][0]=='c' && digi3==1 && isdigit(*argv[5])) sscanf(argv[5],"%d",&digi4);
memsize=(unsigned short)digi1;
limit=(unsigned char) digi2;
LZ=(unsigned char) digi3;
avan=(unsigned char) digi4;
if (argc<3 || argc>8 ){endx();return 1;}
if (argc==7 &&  LZ!=0 && argv[1][0]=='c'){endx();return 1;}
if (argc==8 &&  LZ!=1 && argv[1][0]=='c'){endx();return 1;}
if (argc!=7+LZ && argv[1][0]=='c'){endx();return 1;}
if (argv[1][0]!='c' && argv[1][0]!='d'){endx();return 1;}
if (argv[1][0]=='c' && LZ==1 && (digi1<2 || digi1>65535 || digi2<1 || digi4<1 || digi2>255 || digi4>255 )){endx();}
if (argv[1][0]=='c' && LZ==0 && (digi1<2 || digi1>65535 || digi2<1  || digi2>255   )){endx();}
if (argv[1][0]=='d' && argc!=3 ){endx();}
clock_t start = clock();// Start timer
printf("          _____________________________________________________ \n");
printf("         | Hook v 0.8c ADMC file compressor/archiver, (C) 2007 |\n");
printf("         |        By Nania Francesco Antonio (Italy)           |\n");
printf("         |_____________________________________________________|\n");
///////////// Open file  ///////////////////////////////
  if (argv[1][0]=='c' )
  {
  printf("Memory=%d MBytes",memsize," \n");
  printf(" Limit=%d",limit," \n");
  if (LZ) printf(" LZ enabled step %d \n",avan); 
  else 
  printf(" LZ disabled  \n");
  in=fopen(argv[5+LZ], "rb");
  if (!in) perror(argv[5+LZ]), exit(1);
  out=fopen(argv[6+LZ], "wb");
  if (!out) perror(argv[6+LZ]), exit(1);
  nfi=5+LZ; nfo=6+LZ;
  }
  else
  {
  in=fopen(argv[2], "rb");
  if (!in) perror(argv[2]), exit(1);
  nfi=2; nfo=3;
  }
////////////////////////////////////////////////////////////////////
  int c;
  x1=0; // min
  x2=0xffffff; // max
  x=0;
  maxsize=1<<26; // data read buffer
  buffer = (unsigned char *)malloc(maxsize);
/////// Compress file ////////////////////////////////////////////////
if (argv[1][0]=='c')
{
flimit1=(float)limit;
flimit2=(float)limit;
fseek (in , 0 , SEEK_END);
filesize = ftell (in);
rewind (in);
fwrite (&filesize , 1 , 8 , out);
fwrite (&memsize , 1 , 4 , out);
fwrite (&limit , 1 , 4 , out);
fwrite (&LZ , 1 , 4 , out);
if (LZ==1) fwrite (&avan , 1 ,4, out);
writename(argv[5+LZ]);
createbrain(memsize*1000000);
newscan:
if (scanned+maxsize>filesize) maxsize=filesize-scanned;
pos=0;
umax=0;
fread (buffer , 1 , maxsize , in);
if (detec==0) {detec=1;detectf();fwrite (&profile , 1 , 1 , out);}
if (exeat==1 ) e8e9transform(1, maxsize); //EXE and DLL E8E9 Coder by Ilia Muraviev activated
    
if (LZ==1)  ///// LZP MODE ACTIVATED /////
{
if (memcre==0) {createbrain2(1<<25);memcre=1;}
memset(buf, 0, sizeof(buf));
while (pos<maxsize)
{
c=(unsigned char)Peekb(buffer+pos);
rc1=(gsis1*(Peekb(buffer+pos-3)>>ri1))+(gsis2*(Peekb(buffer+pos-2)>>ri2)<<gl2)+(gsis3*(Peekb(buffer+pos-1)>>ri3)<<gl3);
if ( pos<3 || buf[rc1]<3 || Peekb(buffer+buf[rc1]-3)!=Peekb(buffer+pos-2) || Peekb(buffer+buf[rc1]-2)!=Peekb(buffer+pos-1) )
{cwrite(c);  goto l180;}
rcx=(Peekb(buffer+pos-1)>>di1)+(esis1*(Peekb(buffer+pos-2)>>di2)<<el2)+(esis2*(Peekb(buffer+pos-3)>>4)<<el3);
rposo=buf[rc1]-1;

nev:
if (memcmp(buffer+rposo+umax,buffer+pos+umax,avan)==0 && pos+umax+(avan-1)<maxsize){umax+=avan;goto nev;}

ramax=umax/avan; 
umax=ramax*avan;
l160:
wizard2 = branchmem2+rcx;// FOR BEST DMC ENCODING REDIRECTION ///
if (umax==0) // no LZ
{umax=0;ubi=1;encode(0);cwrite(c);goto l180;}
for (int f=0; f<umax; f++)
for (int i=7; i>=0; --i)
{posbit=i;pupdate((Peekb(buffer+rposo+f)>>i)&1);} 
ubi=1;
encode(1); // LZ
ubi=1;
umax--;
if (ramax==1) 
encode(0);
else
{
rumax=ramax-1;
for (int i=1; i<32; i++)
{
encode(1);
if (rumax<=(1<<i)) 
{
encode(0);
for (int ni=i-1; ni>=0; --ni)
encode(((rumax-1)>>ni)&1);
goto l180;
}
rumax-=(1<<i);    
}
}
l180:
    if (scanned+pos>control*(filesize/100))
    {
    printf("pack %s %d to %d bytes, ratio %f\r",argv[6],(scanned+pos),tot,(float)tot/(scanned+pos));
    control++;
    }
    buf[rc1]=pos+1;
l190:
    pos+=1+umax;
    umax=0;
    }
}
else /// NORMAL ADMC MODE ////////////
    {
    while (pos<maxsize)
    {
    c=(unsigned char)Peekb(buffer+pos);
    cwrite(c);
    if (scanned+pos>control*(filesize/100))
    {
    printf("pack %s %d bytes to %s %d bytes, ratio %f\r",argv[5],(scanned+pos),argv[6],tot,(float)tot/(scanned+pos));
    control++;
    }
    pos++;
    }
    }
       
   scanned+=maxsize;
  if (scanned<filesize) goto newscan;

  for (int i=2; i>=0; --i) //Flush x2
  putc(x2>>(i<<3), out);


  }
////////////////////////// Decompression of file /////////////////
else
{
fread (&filesize , 1 , 8 , in);
fread (&memsize , 1 , 4 , in);
fread (&limit , 1 , 4 , in);
fread (&LZ , 1 , 4 , in);
flimit1=(float)limit;
flimit2=(float)limit;
if (LZ==1) fread (&avan , 1 , 4 , in);
readname();
fread (&profile , 1 , 1 , in);
detectf();
createbrain(memsize*1000000);

for (int i=2; i>=0; --i) // get x
x+=getc(in)<<(i<<3);
   
newdscan:
if (scanned+maxsize>filesize) maxsize=filesize-scanned;
pos=0;
umax=0;
memset(buf, 0, sizeof(buf));
///// LZP MODE ACTIVATED /////
if (LZ==1)
{
if (memcre==0) {createbrain2(1<<25);memcre=1;}
memset(buf, 0, sizeof(buf));
while (pos<maxsize)
{

rc1=(gsis1*(Peekb(buffer+pos-3)>>ri1))+(gsis2*(Peekb(buffer+pos-2)>>ri2)<<gl2)+(gsis3*(Peekb(buffer+pos-1)>>ri3)<<gl3);

if ( pos<3 || buf[rc1]<3 || Peekb(buffer+buf[rc1]-3)!=Peekb(buffer+pos-2) || Peekb(buffer+buf[rc1]-2)!=Peekb(buffer+pos-1) )
{cread();goto l1180;}
rcx=(Peekb(buffer+pos-1)>>di1)+(esis1*(Peekb(buffer+pos-2)>>di2)<<el2)+(esis2*(Peekb(buffer+pos-3)>>4)<<el3);

ubi=1;
wizard2 = branchmem2+rcx;// FOR BEST DMC ENCODING REDIRECTION ///
ok=decode(); 

if (ok==0){cread();goto l1180;} // NO LZP

ubi=1;
ramax=1;
incre=0;
amac2:
ok=decode();
if (ok==0 && incre==0) goto l216;
if (ok==1)
{
ramax+=(1<<incre);
incre++;
goto amac2;
}
c=0;
for (int i=incre-1; i>=0; --i)
c+=c+decode();
ramax+=c;
l216:
umax=ramax*avan;
      
      umax--;
      for (int l=0; l<=umax; l++)
      {
      Pokeb(buffer+pos+l,Peekb(buffer+(buf[rc1]-1)+l));
      for (int i=7; i>=0; --i)
      {posbit=i;pupdate((Peekb(buffer+(buf[rc1]-1)+l)>>i)&1); }
      }
        l1180:
                          if (scanned+pos>control*(filesize/79))
    {
    printf("unpack %s to %s %d / %d bytes\r",argv[2],nf,scanned+pos,filesize);
    control++;
    }
        buf[rc1]=pos+1;
      
        nono:
        pos+=1+umax;
        umax=0;
       }
    }
    else
     while (pos<maxsize) //// NORMAL MODE ////
    {

      ubi=0;
       c = 0;
    for (int i=7; i>=0; --i)
    {posbit=i;c+=c+decode();}
    Pokeb(buffer+pos,c);
    if (scanned+pos>control*(filesize/79))
    {
    printf("unpack %s to %s %d / %d bytes\r",argv[2],nf,scanned+pos,filesize);
    control++;
    }
    pos++;
    }
    if (exeat==1 ) e8e9transform(0, maxsize);
    fwrite (buffer , 1 , maxsize , out);
    scanned+=maxsize;
    if (scanned<filesize) goto newdscan;
}

// Print results /////////////////////////////////////////////////
  if ( argv[1][0]=='c') nf=argv[nfo];
  printf("%s (%ld bytes) compress to %s (%ld bytes) in %1.2f s.\n",
  argv[nfi], ftell(in), nf, ftell(out),((double)clock()-start)/CLOCKS_PER_SEC);

  return 0;

}
      
